#include <windows.h>
#include <stdio.h>
#include <math.h>

BOOL APIENTRY DllMain(HMODULE, DWORD, LPVOID);
void DLLInit();

typedef struct _Track
{
	float tx, ty, tz;
	float hx, hy, hz;
	char exist;
	unsigned long create;
	unsigned long destroy;
	float radius;
	unsigned char alpha;
	char tracer;
	char type;
} Track;
Track* pTrack;
Track* pTrackEnd;

typedef struct _Bullet
{
	unsigned long type;
	void* shooter;
	float destroy;
	char exist;
	char tracer;
	float px, py, pz;
	float vx, vy, vz;
	unsigned short damage;
} Bullet;
Bullet* pBullet;
Bullet* pBulletStart;
Bullet* pBulletEnd;

typedef struct _Pierce
{
	int surftype;
	float sx, sy, sz;
	float force;
	float timer;
} Pierce;
Pierce* pPierce;

typedef struct _WeaponData
{
	unsigned long eFireType;
	float targetRange;
	float weaponRange;
	long modelId1;
	long modelId2;
	unsigned long weaponslot;
	unsigned long flags;
	unsigned long AssocGroupId;
	unsigned short ammoClip;
	unsigned short damage;
	float fireOffsetx;
	float fireOffsety;
	float fireOffsetz;
	unsigned long skillLevel;
	unsigned long reqstatleveltogetthisweaponskilllevel;
	float accuracy;
	float movespeed;
	float animLoopstart;
	float animLoopend;
	float animLoopfire;
	float animLoop2start;
	float animLoop2end;
	float animLoop2fire;
	float breakoutTime;
	float speed;
	float radius;
	float lifespan;
	float spread;
	unsigned char AssocGroupId2;
	unsigned char unknown6D;
	unsigned char baseCombo;
	unsigned char unknown6F;
} WeaponData;

typedef struct _Vector3D
{
	float x, y, z;
} Vector3D;

typedef struct _Hit
{
	Vector3D hit;
	unsigned long padding0;
	Vector3D norm;
	unsigned long padding1;
	unsigned long surface;
	unsigned long unknown;
} Hit;

typedef struct _Weapon
{
	float velocity;
	float dragHead;
	float dragSide;
	float dragPierce;
	float ricochetAdd;
	int tracerRatio;
	float length[2];
	float radius[2];
	unsigned long alpha[2];
	unsigned long tracerColor;
} Weapon;
Weapon* pWeapon;

typedef struct _Surface
{
	float ricochetLimit;
	float ricochetMul;
	float ricochetAdd;
	float scatter;
	float hardness;
} Surface;
Surface* pSurface;

int nBullets = 4096;
int nWeapons = 1;
float fRangeMult = 1.0;
int bEnableGravity = 0;
float fGravityMult = 1.0;
int bEnableAirres = 0;
int bEnableRicochet = 0;
int bEnablePierce = 0;
int nMaxLoop = 4;
float fMinSpeed = .004f;
float fColBias = .01f;
float fSolidBias = .1f;
int nSolidLoop = 50;

int bTrackBreak = 0;
int bBulletBreak = 0;
int bBulletHit = 0;
int bRicocheted = 0;
int bThrough = 0;
int dwM4TracerIndex = 0;
unsigned short nOriginalDamage;

float* const pTimer = (float*)0xB7CB5C;
float fRealTimer;
int bProcAgain = 0;
int nLoopCount = 0;

void Patch_723CCD();
void Patch_7240B5();
void Patch_723F57();
void Patch_73614A();
void Patch_7367EB();
void Patch_73680E();
bool __fastcall MakeBullet(unsigned long* pType, void* pDummy, void* pShoot, void* pHit, Vector3D* p, Vector3D* t, Vector3D* h, void* pUnknown);
bool MakeBullet_Sniper(void* pShoot, unsigned char type, float px, float py, float pz, float vx, float vy, float vz);
bool MakeBullet_M4(Vector3D* p, Vector3D* v, unsigned long damage);
void Gravity();
void Ricochet();
WeaponData* (*GetWeaponData) (unsigned long, unsigned char) = (WeaponData* (*) (unsigned long, unsigned char))0x743C60;
unsigned char (*GetWeaponSkill) (void*) = (unsigned char (*) (void*))0x5E6580;
unsigned char (__fastcall *GetSurfFX) (unsigned long, unsigned long, unsigned long) = (unsigned char (__fastcall *) (unsigned long, unsigned long, unsigned long))0x55E670;
unsigned char (*HitTest) (Vector3D*, Vector3D*, Hit*, void**, bool, bool, bool, bool, bool, bool, bool, bool) = (unsigned char (*) (Vector3D*, Vector3D*, Hit*, void**, bool, bool, bool, bool, bool, bool, bool, bool))0x56BA00;

#define patch(a, v, s) _patch((void*)(a), (void*)(v), (s))
void _patch(void*, void*, int);
#define nop(a, s) _nop((void*)(a), (s))
void _nop(void*, int);
bool check(void*, unsigned char, const char*, bool);
bool _check(void*, unsigned char);

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		DLLInit();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

void DLLInit()
{
	const unsigned char cJump = 0xE9;
	unsigned long dwValue;
	char cBuffer[1024];
	char cPath[MAX_PATH];
	char* cFile;
	int nSize;
	GetModuleFileName(NULL, cPath, MAX_PATH);
	if (strrchr(cPath, '\\')) *(char*)strrchr(cPath, '\\') = '\0';
	cFile = cPath + strlen(cPath);
	nSize = MAX_PATH - strlen(cPath);
	strcpy_s(cFile, nSize, "\\bullet.ini");

	nBullets = GetPrivateProfileInt("BULLET", "MaxBullet", 4096, cPath);
	nWeapons = GetPrivateProfileInt("BULLET", "MaxWeapon", 0, cPath) + 1;
	GetPrivateProfileString("BULLET", "RangeMult", "1.0", cBuffer, 1024, cPath);
	fRangeMult = 40.f * (float)atof(cBuffer);
	bEnableGravity = GetPrivateProfileInt("BULLET", "Gravity", 0, cPath);
	GetPrivateProfileString("BULLET", "GravityMult", "1.0", cBuffer, 1024, cPath);
	fGravityMult = .032f * (float)atof(cBuffer);
	bEnableAirres = GetPrivateProfileInt("BULLET", "AirResist", 0, cPath);
	bEnableRicochet = GetPrivateProfileInt("BULLET", "Ricochet", 0, cPath);
	bEnablePierce = GetPrivateProfileInt("BULLET", "Pierce", 0, cPath);
	nMaxLoop = GetPrivateProfileInt("BULLET", "MaxLoop", 8, cPath);
	GetPrivateProfileString("BULLET", "MinSpeed", "1.0", cBuffer, 1024, cPath);
	fMinSpeed = 25.f * (float)atof(cBuffer);
	GetPrivateProfileString("BULLET", "ColBias", "0.01", cBuffer, 1024, cPath);
	fColBias = (float)atof(cBuffer);
	GetPrivateProfileString("BULLET", "SolidBias", "0.1", cBuffer, 1024, cPath);
	fSolidBias = (float)atof(cBuffer);
	nSolidLoop = GetPrivateProfileInt("BULLET", "SolidLoop", 50, cPath);

	FILE* file;

	pWeapon = (Weapon*)calloc(nWeapons, sizeof(Weapon));
	strcpy_s(cFile, nSize, "\\bullet_weapon.dat");
	fopen_s(&file, cPath, "rt");
	while (true)
	{
		fgets(cBuffer, 1024, file);
		if (cBuffer[0] == ';') continue;
		if (cBuffer[0] == '\0') break;
		dwValue = (unsigned long)atol(cBuffer);
		if (dwValue < 0 || dwValue >= (unsigned)nWeapons) continue;
		sscanf_s(cBuffer, "%*d %f %f %f %f %f %d %f %f %f %f %d %d %x", &pWeapon[dwValue].velocity, &pWeapon[dwValue].dragHead, &pWeapon[dwValue].dragSide, &pWeapon[dwValue].dragPierce, &pWeapon[dwValue].ricochetAdd, &pWeapon[dwValue].tracerRatio,
			&pWeapon[dwValue].length[0], &pWeapon[dwValue].length[1], &pWeapon[dwValue].radius[0], &pWeapon[dwValue].radius[1], &pWeapon[dwValue].alpha[0], &pWeapon[dwValue].alpha[1], &pWeapon[dwValue].tracerColor);
		pWeapon[dwValue].velocity = 25.f / pWeapon[dwValue].velocity;
		pWeapon[dwValue].length[0] *= pWeapon[dwValue].velocity;
		pWeapon[dwValue].length[1] *= pWeapon[dwValue].velocity;
		if (feof(file)) break;
	}
	fclose(file);

	pSurface = (Surface*)calloc(7, sizeof(Surface));
	strcpy_s(cFile, nSize, "\\bullet_surface.dat");
	fopen_s(&file, cPath, "rt");
	while (true)
	{
		fgets(cBuffer, 1024, file);
		if (cBuffer[0] == ';') continue;
		if (cBuffer[0] == '\0') break;
		switch (cBuffer[0])
		{
		case 'N':
			dwValue = 0;
			break;
		case 'S':
			dwValue = (cBuffer[1] == 'P') ? 1 : 2;
			break;
		case 'W':
			dwValue = 3;
			break;
		case 'D':
			dwValue = 4;
			break;
		case 'C':
			dwValue = 5;
			break;
		case 'P':
			dwValue = 6;
			break;
		default:
			dwValue = 7;
			break;
		}
		if (dwValue < 0 || dwValue > 6) continue;
		sscanf_s(cBuffer, "%*s %f %f %f %f %f", &pSurface[dwValue].ricochetLimit, &pSurface[dwValue].ricochetMul, &pSurface[dwValue].ricochetAdd, &pSurface[dwValue].scatter, &pSurface[dwValue].hardness);
		pSurface[dwValue].ricochetMul *= .5f;
		if (feof(file)) break;
	}
	fclose(file);

	pTrack = (Track*)calloc(nBullets, sizeof(Track));
	pTrackEnd = pTrack + nBullets;
	pBullet = (Bullet*)calloc(nBullets, sizeof(Bullet));
	pBulletStart = pBullet;
	pBulletEnd = pBullet + nBullets;
	pPierce = (Pierce*)calloc(nBullets, sizeof(Pierce));

	if (check((void*)0x723CCD, 0xA1, "Track Patch", false))
	{
		dwValue = (unsigned long)&Patch_723CCD - 0x723CD2;
		patch(0x723CCD, &cJump, 1);
		patch(0x723CCE, &dwValue, 4);
	}
	if (check((void*)0x7240B5, 0x5F, "Track Patch", false))
	{
		dwValue = (unsigned long)&Patch_7240B5 - 0x7240BA;
		patch(0x7240B5, &cJump, 1);
		patch(0x7240B6, &dwValue, 4);
	}

	if (check((void*)0x723F57, 0x81, "Track Patch", false))
	{
		dwValue = (unsigned long)&Patch_723F57 - 0x723F5C;
		patch(0x723F57, &cJump, 1);
		patch(0x723F58, &dwValue, 4);
	}

	if (bEnableGravity || bEnableAirres) if (check((void*)0x73614A, 0xD9, "Bullet Patch", false))
	{
		dwValue = (unsigned long)&Gravity - 0x73614F;
		patch(0x73614A, &cJump, 1);
		patch(0x73614B, &dwValue, 4);
	}
	if (check((void*)0x736517, 0x74, "Bullet Patch", false)) nop(0x736517, 2);
	if (check((void*)0x736282, 0x0F, "Bullet Patch", false))
	{
		dwValue = (unsigned long)&Ricochet - 0x736288;
		nop(0x736282, 1);
		patch(0x736283, &cJump, 1);
		patch(0x736284, &dwValue, 4);
	}
	if (check((void*)0x7366C8, 0x0F, "Bullet Patch", false)) nop(0x7366C8, 6);
	if (check((void*)0x73679F, 0x75, "Bullet Patch", false)) nop(0x73679F, 2);
	if (check((void*)0x7367EB, 0x8B, "Bullet Patch", false))
	{
		dwValue = (unsigned long)&Patch_7367EB - 0x7367F0;
		patch(0x7367EB, &cJump, 1);
		patch(0x7367EC, &dwValue, 4);
	}
	if (check((void*)0x73680E, 0x81, "Bullet Patch", false))
	{
		dwValue = (unsigned long)&Patch_73680E - 0x736813;
		patch(0x73680E, &cJump, 1);
		patch(0x73680F, &dwValue, 4);
	}

	if (check((void*)0x73B550, 0x6A, "Make Patch", false))
	{
		dwValue = (unsigned long)&MakeBullet - 0x73B555;
		patch(0x73B550, &cJump, 1);
		patch(0x73B551, &dwValue, 4);
	}

	if (check((void*)0x736010, 0x51, "MakeSniper Patch", false))
	{
		dwValue = (unsigned long)&MakeBullet_Sniper - 0x736015;
		patch(0x736010, &cJump, 1);
		patch(0x736011, &dwValue, 4);
	}

	if (check((void*)0x73AF00, 0x83, "MakeM4 Patch", false))
	{
		dwValue = (unsigned long)&MakeBullet_M4 - 0x73AF05;
		patch(0x73AF00, &cJump, 1);
		patch(0x73AF01, &dwValue, 4);
	}

	return;
}

void __declspec(naked) Patch_723CCD()
{
	__asm
	{
		mov eax, 0xB6F03C;
		mov eax, [eax];
		test byte ptr [esi+0x21], 1;
		jz NONTRACER;
		movzx edi, byte ptr [esi+0x22];
		cmp edi, nWeapons;
		jl TRACER;
		mov edi, 0;

TRACER:
		imul edi, 0x34;
		add edi, pWeapon;
		mov edi, dword ptr [edi+0x30];
		push 0x723CD2;
		ret;

NONTRACER:
		mov edi, 0x00FFFF80;
		push 0x723CD2;
		ret;
	}
}

void __declspec(naked) Patch_7240B5()
{
	__asm
	{
		push ebp;
		mov ebp, esp;
	}
	for (int i = 0; i < nBullets; i++)
	{
		pTrack[i].exist = pBullet[i].exist;
		if (!pBullet[i].exist) continue;
		pTrack[i].tx = pBullet[i].px - pBullet[i].vx * (pWeapon[pBullet[i].type < (unsigned)nWeapons ? pBullet[i].type : 0].length[pBullet[i].tracer ? 1 : 0] - pPierce[i].timer);
		pTrack[i].ty = pBullet[i].py - pBullet[i].vy * (pWeapon[pBullet[i].type < (unsigned)nWeapons ? pBullet[i].type : 0].length[pBullet[i].tracer ? 1 : 0] - pPierce[i].timer);
		pTrack[i].tz = pBullet[i].pz - pBullet[i].vz * (pWeapon[pBullet[i].type < (unsigned)nWeapons ? pBullet[i].type : 0].length[pBullet[i].tracer ? 1 : 0] - pPierce[i].timer);
		pPierce[i].timer -= *pTimer / 2.f;
		if (pPierce[i].timer < 0.f) pPierce[i].timer = 0.f;
		pTrack[i].hx = pBullet[i].px;
		pTrack[i].hy = pBullet[i].py;
		pTrack[i].hz = pBullet[i].pz;
		pTrack[i].create = *(unsigned long*)0xB7CB84;
		pTrack[i].destroy = 0x7FFFFFFF;
		pTrack[i].radius = pWeapon[pBullet[i].type < (unsigned)nWeapons ? pBullet[i].type : 0].radius[pBullet[i].tracer ? 1 : 0];
		pTrack[i].alpha = (unsigned char)pWeapon[pBullet[i].type < (unsigned)nWeapons ? pBullet[i].type : 0].alpha[pBullet[i].tracer ? 1 : 0];
		pTrack[i].tracer = pBullet[i].tracer;
		pTrack[i].type = (signed)pBullet[i].type;
		if (!pTrack[i].exist) continue;
		if (*(unsigned long*)0xB7CB84 - pTrack[i].create > pTrack[i].destroy) pTrack[i].exist = 0;
	}
	__asm
	{
		pop ebp;
		pop edi;
		pop esi;
		pop ebx;
		ret;
	}
}

void __declspec(naked) Patch_723F57()
{
	if (!bTrackBreak)
	{
		__asm
		{
			cmp esi, 0xC7CA10;
			jge BREAK0;
			push 0x723CC2;
			ret;

BREAK0:
			mov bTrackBreak, 1;
			mov esi, pTrack;
			add esi, 8;
			push 0x723CC2;
			ret;
		}
	} else
	{
		__asm
		{
			cmp esi, pTrackEnd;
			jge BREAK1;
			push 0x723CC2;
			ret;

BREAK1:
			mov bTrackBreak, 0;
			push 0x723F63;
			ret;
		}
	}
}

void __declspec(naked) Patch_7367EB()
{
	__asm
	{
		test bBulletBreak, 1;
		jz BREAK;
		test bBulletHit, 1;
		jz BREAK;
		mov bBulletHit, 0;
		mov ax, nOriginalDamage;
		mov [edi+0x24], ax;
		test bProcAgain, 1;
		jz BREAK;
		push 0x73680B;
		ret;

BREAK:
		mov ecx, [esp+0x14];
		mov edx, [esp+0x18];
		push 0x7367F3;
		ret;
	}
}

void __declspec(naked) Patch_73680E()
{
	if (!bBulletBreak)
	{
		__asm
		{
			cmp edi, 0xC888A4;
			jge BREAK0;
			push 0x7360E7;
			ret;

BREAK0:
			mov ecx, dword ptr [pTimer];
			mov eax, dword ptr [ecx];
			mov fRealTimer, eax;
			mov bBulletBreak, 1;
			mov bProcAgain, 0;
			mov nLoopCount, 0;
			mov edi, pBullet;
			add edi, 4;
			push 0x7360E7;
			ret;
		}
	} else
	{
		__asm
		{
			test bProcAgain, 1;
			jz BREAK1;
			mov bProcAgain, 0;
			mov eax, nLoopCount;
			cmp eax, nMaxLoop;
			jge BREAK1;
			inc nLoopCount;
			sub edi, 0x2C;
			push 0x7360E7;
			ret;

BREAK1:
			mov nLoopCount, 0;
			mov ecx, dword ptr [pTimer];
			mov eax, fRealTimer;
			mov dword ptr [ecx], eax;
			cmp edi, pBulletEnd;
			jge BREAK2;
			push 0x7360E7;
			ret;

BREAK2:
			mov bBulletBreak, 0;
			push 0x73681A;
			ret;
		}
	}
}

bool __fastcall MakeBullet(unsigned long* pType, void* pDummy, void* pShoot, void* pHit, Vector3D* p, Vector3D* t, Vector3D* h, void* pUnknown)
{
	Weapon* pCurWeapon = &pWeapon[*pType < (unsigned)nWeapons ? *pType : 0];
	Vector3D* v = pHit ? h : t;
	v->x -= p->x;
	v->y -= p->y;
	v->z -= p->z;
	float vs = sqrt(v->x * v->x + v->y * v->y + v->z * v->z) * pCurWeapon->velocity;
	for (int i = 0; i < nBullets; i++)
	{
		if (pBullet[i].exist) continue;
		pBullet[i].type = *pType;
		pBullet[i].shooter = pShoot;
		pBullet[i].destroy = (float)*(unsigned long*)0xB7CB84 + GetWeaponData(*pType, pShoot ? GetWeaponSkill(pShoot) : 1)->weaponRange * pCurWeapon->velocity * fRangeMult;
		pBullet[i].exist = 1;
		pBullet[i].tracer = pCurWeapon->tracerRatio ? (((*((unsigned char*)pShoot + 0x36) & 0x07) == 3) ? (*(unsigned short*)((unsigned char*)pShoot + 0x5A8 + *((unsigned char*)pShoot + 0x718) * 0x1C) - 1) % pCurWeapon->tracerRatio : dwM4TracerIndex++ % pCurWeapon->tracerRatio) ? 0 : 1 : 0;
		pBullet[i].px = p->x;
		pBullet[i].py = p->y;
		pBullet[i].pz = p->z;
		pBullet[i].vx = v->x / vs;
		pBullet[i].vy = v->y / vs;
		pBullet[i].vz = v->z / vs;
		pBullet[i].damage = GetWeaponData(*pType, pShoot ? GetWeaponSkill(pShoot) : 1)->damage;
		pPierce[i].timer = pCurWeapon->length[pBullet[i].tracer];
		break;
	}
	return false;
}

bool MakeBullet_Sniper(void* pShoot, unsigned char type, float px, float py, float pz, float vx, float vy, float vz)
{
	Weapon* pCurWeapon = &pWeapon[type < (unsigned)nWeapons ? type : 0];
	float vs = sqrt(vx * vx + vy * vy + vz * vz) * pCurWeapon->velocity;
	for (int i = 0; i < nBullets; i++)
	{
		if (pBullet[i].exist) continue;
		pBullet[i].type = type;
		pBullet[i].shooter = pShoot;
		pBullet[i].destroy = (float)*(unsigned long*)0xB7CB84 + GetWeaponData(type, pShoot ? GetWeaponSkill(pShoot) : 1)->weaponRange * pCurWeapon->velocity * fRangeMult;
		pBullet[i].exist = 1;
		pBullet[i].tracer = pCurWeapon->tracerRatio ? (((*((unsigned char*)pShoot + 0x36) & 0x07) == 3) ? (*(unsigned short*)((unsigned char*)pShoot + 0x5A8 + *((unsigned char*)pShoot + 0x718) * 0x1C) - 1) % pCurWeapon->tracerRatio : dwM4TracerIndex++ % pCurWeapon->tracerRatio) ? 0 : 1 : 0;
		pBullet[i].px = px;
		pBullet[i].py = py;
		pBullet[i].pz = pz;
		pBullet[i].vx = vx / vs;
		pBullet[i].vy = vy / vs;
		pBullet[i].vz = vz / vs;
		pBullet[i].damage = GetWeaponData(type, pShoot ? GetWeaponSkill(pShoot) : 1)->damage;
		pPierce[i].timer = pCurWeapon->length[pBullet[i].tracer];
		break;
	}
	return false;
}

bool MakeBullet_M4(Vector3D* p, Vector3D* v, unsigned long damage)
{
	Weapon* pCurWeapon = &pWeapon[31 < (unsigned)nWeapons ? 31 : 0];
	v->x -= p->x;
	v->y -= p->y;
	v->z -= p->z;
	float vs = sqrt(v->x * v->x + v->y * v->y + v->z * v->z) * pCurWeapon->velocity;
	for (int i = 0; i < nBullets; i++)
	{
		if (pBullet[i].exist) continue;
		pBullet[i].type = 31;
		pBullet[i].shooter = NULL;
		pBullet[i].destroy = (float)*(unsigned long*)0xB7CB84 + vs * fRangeMult;
		pBullet[i].exist = 1;
		pBullet[i].tracer = pCurWeapon->tracerRatio ? (dwM4TracerIndex++ % pCurWeapon->tracerRatio) ? 0 : 1 : 0;
		pBullet[i].px = p->x;
		pBullet[i].py = p->y;
		pBullet[i].pz = p->z;
		pBullet[i].vx = v->x / vs;
		pBullet[i].vy = v->y / vs;
		pBullet[i].vz = v->z / vs;
		pBullet[i].damage = (unsigned short)damage;
		pPierce[i].timer = pCurWeapon->length[pBullet[i].tracer];
		break;
	}
	return false;
}

void __stdcall _Gravity(Bullet* pBullet, float time)
{
	Weapon* pCurWeapon = &pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0];
	if (bEnableGravity) pBullet->vz -= fGravityMult * time;
	if (!bEnableAirres) return;
	Vector3D vel = {pBullet->vx, pBullet->vy, pBullet->vz};
	float dist = sqrt(vel.x * vel.x + vel.y * vel.y + vel.z * vel.z);
	vel.x /= dist;
	vel.y /= dist;
	vel.z /= dist;
	pBullet->vx -= *(float*)0xC813E0 * .2f;
	pBullet->vy -= *(float*)0xC813E4 * .2f;
	pBullet->vz -= *(float*)0xC813E8 * .2f;
	dist = vel.x * pBullet->vx + vel.y * pBullet->vy + vel.z * pBullet->vz;
	vel.x *= dist;
	vel.y *= dist;
	vel.z *= dist;
	pBullet->vx -= vel.x;
	pBullet->vy -= vel.y;
	pBullet->vz -= vel.z;
	pBullet->vx -= pBullet->vx * abs(pBullet->vx) * pCurWeapon->dragSide * time;
	pBullet->vy -= pBullet->vy * abs(pBullet->vy) * pCurWeapon->dragSide * time;
	pBullet->vz -= pBullet->vz * abs(pBullet->vz) * pCurWeapon->dragSide * time;
	vel.x -= vel.x * abs(vel.x) * pCurWeapon->dragHead * time;
	vel.y -= vel.y * abs(vel.y) * pCurWeapon->dragHead * time;
	vel.z -= vel.z * abs(vel.z) * pCurWeapon->dragHead * time;
	pBullet->vx += vel.x;
	pBullet->vy += vel.y;
	pBullet->vz += vel.z;
	pBullet->vx += *(float*)0xC813E0 * .2f;
	pBullet->vy += *(float*)0xC813E4 * .2f;
	pBullet->vz += *(float*)0xC813E8 * .2f;
	return;
}

void __declspec(naked) Gravity()
{
	__asm
	{
		pushad;
		sub esp, 0x0C;
		fst [esp];
		fstp [esp+4];
		sub edi, 4;
		push edi;
		call _Gravity;
		fld [esp];
		add esp, 0x8;
		popad;
		fld st;
		fmul [edi+0x18];
		push 0x73614F;
		ret;
	}
}

void __stdcall _Ricochet(Bullet* pBullet, const Vector3D* pPosition, const Vector3D* pNormal, unsigned long dwSurface, unsigned char nType)
{
	bBulletHit = 1;
	int surftype;
	switch (nType)
	{
	case 3:
		surftype = 6;
		break;
	case 2:
		surftype = 5;
		break;
	default:
		surftype = GetSurfFX(0xB79538, NULL, dwSurface);
		break;
	}
	float norm, vel, dist, mult;
	vel = sqrt(pBullet->vx * pBullet->vx + pBullet->vy * pBullet->vy + pBullet->vz * pBullet->vz);
	if (vel < fMinSpeed)
	{
		pBullet->exist = 0;
		bProcAgain = 0;
		bThrough = 1;
		return;
	}
	norm = (pBullet->vx * pNormal->x + pBullet->vy * pNormal->y + pBullet->vz * pNormal->z) * 2.f;
	dist = sqrt((pBullet->px - pPosition->x) * (pBullet->px - pPosition->x) + (pBullet->py - pPosition->y) * (pBullet->py - pPosition->y) + (pBullet->pz - pPosition->z) * (pBullet->pz - pPosition->z));
	nOriginalDamage = pBullet->damage;
	pBullet->damage = (unsigned short)(vel * vel * pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0].velocity * pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0].velocity * (float)nOriginalDamage);
	bRicocheted = 0;
	if (bEnableRicochet) if (norm < 0.f) if (abs(norm / vel * .5f) < pSurface[surftype].ricochetLimit + pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0].ricochetAdd)
	{
		pBullet->exist = 1;
		pBullet->px = pPosition->x;
		pBullet->py = pPosition->y;
		pBullet->pz = pPosition->z;
		pBullet->damage = (unsigned short)(max(0.f, min(1.f, abs(norm / vel * pSurface[surftype].ricochetMul) + pSurface[surftype].ricochetAdd)) * (float)pBullet->damage);
		mult = max(0.f, min(1.f, (1.f - abs(norm / vel * pSurface[surftype].ricochetMul) + pSurface[surftype].ricochetAdd)));
		mult *= mult;
		pBullet->vx -= pNormal->x * norm;
		pBullet->vy -= pNormal->y * norm;
		pBullet->vz -= pNormal->z * norm;
		norm /= sqrt(pBullet->vx * pBullet->vx + pBullet->vy * pBullet->vy + pBullet->vz * pBullet->vz);
		norm = fColBias / abs(norm);
		pBullet->px += pBullet->vx / vel * norm;
		pBullet->py += pBullet->vy / vel * norm;
		pBullet->pz += pBullet->vz / vel * norm;
		dist += norm;
		pBullet->vx += ((float)rand() / (float)RAND_MAX - .5f) * vel * pSurface[surftype].scatter;
		pBullet->vy += ((float)rand() / (float)RAND_MAX - .5f) * vel * pSurface[surftype].scatter;
		pBullet->vz += ((float)rand() / (float)RAND_MAX - .5f) * vel * pSurface[surftype].scatter;
		norm = sqrt(pBullet->vx * pBullet->vx + pBullet->vy * pBullet->vy + pBullet->vz * pBullet->vz) / vel / mult;
		pBullet->vx /= norm;
		pBullet->vy /= norm;
		pBullet->vz /= norm;
		*pTimer = (vel * fRealTimer - dist) / vel;
		bRicocheted = 1;
		bProcAgain = 1;
	}
	if (bEnablePierce) if (!bRicocheted) if (pSurface[surftype].hardness >= 0.f)
	{
		int index = (pBullet - pBulletStart) / sizeof(Bullet);
		pBullet->exist = 1;
		pBullet->px = pPosition->x;
		pBullet->py = pPosition->y;
		pBullet->pz = pPosition->z;
		if (norm < 0.f)
		{
			norm /= sqrt(pBullet->vx * pBullet->vx + pBullet->vy * pBullet->vy + pBullet->vz * pBullet->vz);
			norm = fColBias / abs(norm);
			pBullet->px += pBullet->vx / vel * norm;
			pBullet->py += pBullet->vy / vel * norm;
			pBullet->pz += pBullet->vz / vel * norm;
			dist += norm;
			pPierce[index].surftype = surftype;
			pPierce[index].sx = pPosition->x;
			pPierce[index].sy = pPosition->y;
			pPierce[index].sz = pPosition->z;
			pPierce[index].force = vel * vel * pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0].velocity * pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0].velocity * (float)nOriginalDamage;
		} else
		{
			pBullet->damage = 0;
			norm /= sqrt(pBullet->vx * pBullet->vx + pBullet->vy * pBullet->vy + pBullet->vz * pBullet->vz);
			norm = fColBias / abs(norm);
			pBullet->px += pBullet->vx / vel * norm;
			pBullet->py += pBullet->vy / vel * norm;
			pBullet->pz += pBullet->vz / vel * norm;
			dist += norm;
			norm = sqrt((pPierce[index].sx - pPosition->x) * (pPierce[index].sx - pPosition->x) + (pPierce[index].sy - pPosition->y) * (pPierce[index].sy - pPosition->y) + (pPierce[index].sz - pPosition->z) * (pPierce[index].sz - pPosition->z));
			norm *= pSurface[surftype].hardness * pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0].dragPierce;
			pPierce[index].force -= norm;
			if (pPierce[index].force < 0.f)
			{
				pBullet->exist = 0;
				bProcAgain = 0;
				bThrough = 1;
				return;
			}
			pPierce[index].force /= pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0].velocity * pWeapon[pBullet->type < (unsigned)nWeapons ? pBullet->type : 0].velocity * (float)nOriginalDamage;
			pPierce[index].force = sqrt(pPierce[index].force);
			pPierce[index].force /= vel;
			pBullet->vx *= pPierce[index].force;
			pBullet->vy *= pPierce[index].force;
			pBullet->vz *= pPierce[index].force;
			bThrough = 1;
		}
		*pTimer = (vel * fRealTimer - dist) / vel;
		bProcAgain = 1;
	}
	vel = sqrt(pBullet->vx * pBullet->vx + pBullet->vy * pBullet->vy + pBullet->vz * pBullet->vz);
	vel /= fColBias;
	Vector3D from, to;
	Hit hit;
	void* pEntity;
	from = *(Vector3D*)&pBullet->px;
	to = from;
	to.x += pBullet->vx / vel;
	to.y += pBullet->vy / vel;
	to.z += pBullet->vz / vel;
	if (HitTest(&from, &to, &hit, &pEntity, true, true, true, true, true, false, false, true))
	{
		vel *= fColBias;
		vel /= fSolidBias;
		to = from;
		to.x += pBullet->vx / vel;
		to.y += pBullet->vy / vel;
		to.z += pBullet->vz / vel;
		for (int i = 0; i < nSolidLoop; i++)
		{
			if (!HitTest(&from, &to, &hit, &pEntity, true, true, true, true, true, false, false, true)) break;
			if (i == nSolidLoop - 1)
			{
				pBullet->exist = 0;
				bProcAgain = 0;
				bThrough = 1;
				return;
			}
			from = to;
			to.x += pBullet->vx / vel;
			to.y += pBullet->vy / vel;
			to.z += pBullet->vz / vel;
		}
		*(Vector3D*)&pBullet->px = from;
	}
	return;
}

void __declspec(naked) Ricochet()
{
	__asm
	{
		test bBulletBreak, 1;
		jz BREAK0;
		pusha;
		push eax;
		movzx eax, byte ptr [esp+0x6B];
		lea ecx, [esp+0x48];
		push eax;
		push ecx;
		lea edx, [esp+0x40];
		push edx;
		sub edi, 4;
		push edi;
		call _Ricochet;
		popa;
		test bThrough, 1;
		jz BREAK0;
		mov bThrough, 0;
		push 0x73677C;
		ret;

BREAK0:
		cmp al, 3;
		je BREAK1;
		push 0x7363F2;
		ret;

BREAK1:
		push 0x736288;
		ret;
	}
}

void _patch(void* pAddress, void* pData, int iSize)
{
	unsigned long dwProtect[2];
	VirtualProtect(pAddress, iSize, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	memcpy(pAddress, pData, iSize);
	VirtualProtect(pAddress, iSize, dwProtect[0], &dwProtect[1]);
}

void _nop(void* pAddress, int iSize)
{
	unsigned long dwProtect[2];
	VirtualProtect(pAddress, iSize, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	memset(pAddress, 0x90, iSize);
	VirtualProtect(pAddress, iSize, dwProtect[0], &dwProtect[1]);
}

bool check(void* pAddress, unsigned char cByte, const char* sExp, bool bContinue)
{
	if (_check(pAddress, cByte)) return true;
	if (bContinue) return false;
	char buf[1024];
	sprintf_s(buf, 1024, "An unknown code found at 0x%08X (%s).\nDo you want to continue without this Function?", pAddress, sExp);
	if (MessageBox(0, buf, "Bullet", MB_YESNO | MB_ICONERROR | MB_DEFBUTTON2) == IDNO) ExitProcess(0);
	return false;
}

bool _check(void* pAddress, unsigned char cByte)
{
	unsigned long dwProtect[2];
	unsigned char cValue = cByte;
	VirtualProtect(pAddress, 1, PAGE_EXECUTE_READ, &dwProtect[0]);
	memcpy(&cValue, pAddress, 1);
	VirtualProtect(pAddress, 1, dwProtect[0], &dwProtect[1]);
	return (cValue == cByte);
}
